/**
 * $Id$
 * LOGICAL-PARADOX.ORG
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 */
package org.logical_paradox.console.event.history;

import java.util.ArrayList;

/**
 * qXghCo
 * @author satoshi akabane@logical-paradox.org
 * @version $Revision$
 */
public class HistoryDriver {
	/** qXgƂċL^郌R[h */
	public static final int HISTORY_BUFFER_SIZE = 16;

	/** qXg */
	private ArrayList history = new ArrayList();

	/** ݂̃J[\ʒu */
	private int pos = 0;

	/** qXgobt@̃TCY */
	private final int historyBufferSize;

	/**
	 * RXgN^
	 */
	public HistoryDriver() {
		this(HISTORY_BUFFER_SIZE);
	}
	/**
	 * RXgN^
	 * @param hbs qXgobt@̃TCY
	 */
	public HistoryDriver(int hbs) {
		historyBufferSize = hbs;
	}
	/**
	 * ɃR[hǉ
	 * @param line 
	 */
	public void addHistory(String line) {
		synchronized(history) {
			history.add(line);
			while(historyBufferSize < history.size()) {
				history.remove(0);
			}
		}
	}
	/**
	 * ȑO̗Ԃ
	 * @return 
	 */
	public String back() {
		String line = null;
		synchronized(history) {
			if(history.size() <= pos) {
				pos = history.size() -1;
			}
			line = (String)history.get(pos);
			pos--;

			if(pos < 0) {
				pos = history.size() -1;
			}
		}
		return line;
	}
	/**
	 * ̗Ԃ
	 * @return 
	 */
	public String forward() {
		String line = null;
		synchronized(history) {
			if(history.size() <= pos) {
				pos = 0;
			}
			line = (String)history.get(pos);
			pos++;

			if(pos == history.size()) {
				pos = 0;
			}
		}
		return line;
	}
}
